part of tecfy_core_client_package;

class TecfyCoreApp extends StatelessWidget {
  static GlobalKey<NavigatorState> appGlobalkey = GlobalKey<NavigatorState>();
  // static GlobalKey<ScaffoldState> appGlobalPagekey = GlobalKey<ScaffoldState>();
  static set apiURL(v) => ConfigService.apiURL = v;
  static set wsURL(v) => ConfigService.wsURL = v;
  // static String wsURL = '';
  static Map<String, IEntityTransaction> entityServices =
      Map<String, IEntityTransaction>();
  static Map<String, IEntityAction> entityActionsServices =
      Map<String, IEntityAction>();
  static set themeConfig(IThemeConfig v) => TecfyBasicApp.themeConfig = v;
  static IThemeConfig get themeConfig => TecfyBasicApp.themeConfig;
  static Image logo;
  static Image backgoundImage;
  static ITranslateService translateService;
  static IReportService reportService;
  static void Function(BuildContext) navigateToDefaultPage = (c) =>
      AppNavigator.navigateToNamed(c, '/',
          replaceAll: true, animationType: AnimationTypes.opacity);
  static Future Function(Database, int, int) updateSqlLiteDb =
      (d, f, t) async {};
  static int appDbVersion = 0;
  static IMenuInterface menuService;
  static PackageInfo packageInfo;
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    // kReleaseMode;
    // if (kReleaseMode) {
    return StreamBuilder<Language>(
        stream: AppLocale.languageStream,
        initialData: LocalConfigService.language,
        builder: (context, languageSnapshot) {
          AppLocale.appLocale = null;
          return getApp(languageSnapshot.data);
        });
    // } else {
    //   return getApp(LocalConfigService.language);
    // }
  }

  getApp(Language language) {
    return MaterialApp(
      key: UniqueKey(),
      title: 'Application',
      navigatorKey: appGlobalkey,
      builder: BotToastInit(),
      theme: ThemeService.getMainThemeAndroid(),
      supportedLocales: [const Locale('ar', 'SA'), const Locale('en', 'US')],
      localizationsDelegates: [
        const AppLocalizationsDelegate(),
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate,
        DefaultCupertinoLocalizations.delegate
      ],
      locale: language == Language.arabic
          ? const Locale('ar', 'SA')
          : const Locale('en', 'US'),
      localeResolutionCallback:
          (Locale deviceLocale, Iterable<Locale> supportedLocales) {
        ConfigService.isRTL = (language == Language.arabic);
        var selectedLanguageCode = (language == Language.arabic) ? 'ar' : 'en';
        var lcl = supportedLocales
                .where((d) => d.languageCode == selectedLanguageCode)
                .first ??
            supportedLocales.first;
        return lcl;
      },
      //home: SplashScreenPage(),
      onGenerateRoute: (RouteSettings settings) {
        if (!InitService.isInitled)
          return GeneratePageRoute(
              widget: SplashScreenPage(), routeName: settings.name);
        switch (settings.name) {
          case '/':
            return GeneratePageRoute(
                widget: DashboardPage(), routeName: settings.name);
          case '/loading':
            return GeneratePageRoute(
                widget: SplashScreenPage(), routeName: settings.name);
          case '/login':
            return GeneratePageRoute(
                widget: LoginPage(), routeName: settings.name);
          case '/setting':
            return GeneratePageRoute(
                widget: SettingPage(), routeName: settings.name);
          default:
            return GeneratePageRoute(
                widget: DashboardPage(), routeName: settings.name);
        }
      },
      initialRoute: '/loading',
    );
  }

  static void init({String mapAPI}) {
    if (!kIsWeb && (Platform.isWindows || Platform.isLinux)) {
      // Initialize FFI
      sqfliteFfiInit();
      // Change the default factory
      databaseFactory = databaseFactoryFfi;
    }
    if (mapAPI != null) {
      //GoogleMap.init(mapAPI);
    }
  }
}

class GeneratePageRoute extends PageRouteBuilder {
  final Widget widget;
  final String routeName;
  GeneratePageRoute({this.widget, this.routeName})
      : super(
          settings: RouteSettings(name: routeName),
          pageBuilder: (BuildContext context, Animation<double> animation,
              Animation<double> secondaryAnimation) {
            return widget;
          },
        );
}
